//
//  NSFileManager(TRAdditions).m
//  Tryst
//
//  Created by Francisco Tolmasky on Sat Mar 13 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "NSArray+TRAdditions.h"


@implementation NSArray (TRAdditions)

- (NSString *)firstPathOrSubpathMatchingExtensions:(NSArray *)filterTypes
{
	int i= 0,
		length= [self count];
	
	NSFileManager *fileManager= [NSFileManager defaultManager];
	
	NSString *path;
	BOOL isDirectory;
	
	for(;i<length;++i)
	{
		path= [self objectAtIndex: i];
		
		[fileManager fileExistsAtPath: path isDirectory: &isDirectory];
		
		if(isDirectory)
		{
			NSArray *paths= [[fileManager subpathsAtPath: path] pathsMatchingExtensions: filterTypes];
			if([paths count]) return [paths objectAtIndex: 0];
		}
		else if([filterTypes containsObject: [path pathExtension]]) return path;
	}
	
	return nil;
}

- (NSArray *)pathsAndSubpathsMatchingExtensions:(NSArray *)filterTypes
{
	int i= 0,
		length= [self count];
	
	NSFileManager *fileManager= [NSFileManager defaultManager];
	
	NSMutableArray *pathsAndSubpaths= [[NSMutableArray alloc] init];
	
	NSString *path;
	BOOL isDirectory;
	
	for(;i<length;++i)
	{
		path= [self objectAtIndex: i];
		
		[fileManager fileExistsAtPath: path isDirectory: &isDirectory];
		
		if(isDirectory)
		{
			NSArray *subpaths= [[fileManager subpathsAtPath: path] pathsMatchingExtensions: filterTypes];
			
			int i= 0,
				length= [subpaths count];
			
			for(;i<length;++i) [pathsAndSubpaths addObject: [NSString stringWithFormat: @"%@/%@", path, [subpaths objectAtIndex: i]]];
		}
		else if([filterTypes containsObject: [path pathExtension]]) [pathsAndSubpaths addObject: path];
	}
	
	return [pathsAndSubpaths autorelease];
}

@end
