//
//  NSString(TRDrawingAdditions).m
//  Tryst
//
//  Created by Francisco Tolmasky on Fri Jan 23 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Carbon/Carbon.h>
#import "NSString+TRDrawingAdditions.h"


@implementation NSString(TRDrawingAdditions)

+ (NSString *)stringWithFileSize:(unsigned)bytes
{
	if(bytes>1073741824) return [NSString stringWithFormat: @"%.1f GB", bytes/1073741824.0];
	else if(bytes>1048576) return [NSString stringWithFormat: @"%.1f MB", bytes/1048576.0];
	return [NSString stringWithFormat: @"%.1f KB", bytes/1024.0];
}

- (NSAttributedString *)truncatedStringWithAttributes:(NSDictionary *)attributes
    width:(float)aWidth
{
    NSMutableString *text = [self mutableCopy];
    NSMutableAttributedString *s = [NSAttributedString alloc];
    OSStatus err= TruncateThemeText((CFMutableStringRef) text, kThemeViewsFont,
                        kThemeStateActive, aWidth, truncEnd, NULL);
    if (err != noErr) NSLog(@"TruncateThemeText failed with error %d", err);
    // XXX Should be able to skip the above by using NSLineBreakByTruncatingMiddle,
    // XXX but OS X 10.1 doesn't implement it yet.
    s = [s initWithString: text attributes: attributes];
    [text release];
    return s;
}

@end
