//
//  NSFileManager(TRAdditions).m
//  Tryst
//
//  Created by Francisco Tolmasky on Sat Mar 13 2004.
//  Copyright (c) 2004 Francisco Tolmasky. All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.


#import "NSArray+TRAdditions.h"


@implementation NSArray (TRAdditions)

- (NSString *)firstPathOrSubpathMatchingExtensions:(NSArray *)filterTypes
{
	int i= 0,
		length= [self count];
	
	NSFileManager *fileManager= [NSFileManager defaultManager];
	
	NSString *path;
	BOOL isDirectory;
	
	for(;i<length;++i)
	{
		path= [self objectAtIndex: i];
		
		[fileManager fileExistsAtPath: path isDirectory: &isDirectory];
		
		if(isDirectory)
		{
			NSArray *paths= [[fileManager subpathsAtPath: path] pathsMatchingExtensions: filterTypes];
			if([paths count]) return [paths objectAtIndex: 0];
		}
		else if([filterTypes containsObject: [path pathExtension]]) return path;
	}
	
	return nil;
}

- (NSArray *)pathsAndSubpathsMatchingExtensions:(NSArray *)filterTypes
{
	int i= 0,
		length= [self count];
	
	NSFileManager *fileManager= [NSFileManager defaultManager];
	
	NSMutableArray *pathsAndSubpaths= [[NSMutableArray alloc] init];
	
	NSString *path;
	BOOL isDirectory;
	
	for(;i<length;++i)
	{
		path= [self objectAtIndex: i];
		
		[fileManager fileExistsAtPath: path isDirectory: &isDirectory];
		
		if(isDirectory)
		{
			NSArray *subpaths= [[fileManager subpathsAtPath: path] pathsMatchingExtensions: filterTypes];
			
			int i= 0,
				length= [subpaths count];
			
			for(;i<length;++i) [pathsAndSubpaths addObject: [NSString stringWithFormat: @"%@/%@", path, [subpaths objectAtIndex: i]]];
		}
		else if([filterTypes containsObject: [path pathExtension]]) [pathsAndSubpaths addObject: path];
	}
	
	return [pathsAndSubpaths autorelease];
}

@end
