//
//  TRTableView.m
//  Tryst
//
//  Created by Francisco Tolmasky on Wed Nov 26 2003.
//  Copyright (c) 2004 Francisco Tolmasky. All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
//

#import "TRMovieCell.h"
#import "TRMovieTableView.h"


@implementation TRMovieTableView

- (id)initWithCoder:(NSCoder *)aCoder
{
    self= [super initWithCoder: aCoder];
    if(self)
    {
        [[[self tableColumns] objectAtIndex: 0]
            setDataCell: [[TRMovieCell allocWithZone: [self zone]] init]];

		[self setVerticalMotionCanBeginDrag: NO];
		
		[self registerForDraggedTypes: [NSArray arrayWithObject: NSFilenamesPboardType]];
    }
    return self;
}

- (void)awakeFromNib
{
	[self setTarget: [[self window] windowController]];
	[self setDoubleAction: @selector(doubleSubscribe:)];
}

- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
    //[super observeValueForKeyPath: keyPath ofObject: object change: change context: context];    [self setNeedsDisplay: YES];
}

- (void)mouseDown:(NSEvent *)theEvent
{
	[super mouseDown: theEvent];
	if(self==[[self window] firstResponder]) [movieListingController rearrangeObjects];
}

- (void)keyDown:(NSEvent *)theEvent
{
	[self interpretKeyEvents: [NSArray arrayWithObject: theEvent]]; 
}

- (void)deleteBackward:(id)sender
{
	[movieListingController remove: self];
}

- (NSDragOperation)draggingSourceOperationMaskForLocal:(BOOL)flag
{
	return NSDragOperationCopy;
}

@end